//Author: Yusuf Sahillioglu
//Aim: Apply ICP to a given point set (in .xyz format) in order to rigidly align it with another point set

#include "Mesh.h" //screen object

int main(int argc, char ** argv)
{
	int nMaxIters = 407; //this default can be overwritten by the user
	cout << "Yusuf's cool implementation of the seminal ICP paper\n\n";
	cout << "1 optional parameter to set the # of max ICP iterations: MyICP.exe <nMaxIters>\n\n";
	if (argc == 2)
	{
		nMaxIters = atoi(argv[1]);
	}
	else
		cout << "no input so using default nMaxIters = 407";
	
	//meshes; they're indeed pure point clouds but this name remained from an ex-project so let's keep it that way
	Mesh* mesh1 = new Mesh(), * mesh2 = new Mesh();

	//load point clouds as mesh vertices
	mesh1->loadPnt("a.xyz");
	mesh2->loadPnt("b.xyz");

	//transform mesh1 so that it aligns with mesh2
	mesh1->ICP(mesh2, false, nMaxIters);

	//write resulting pointset to file
	mesh1->resultToFile("a_out.xyz");

	return 0;
}
